//go:build webp

package convert

import (
	"image"
	"io"

	"github.com/bep/gowebp/libwebp"
	"github.com/bep/gowebp/libwebp/webpoptions"

	// Нужно включать в сборку для вызова регистрации декодера в стандартном
	// пакете "images" для декодирования файлов webp.
	_ "golang.org/x/image/webp"
)

const (
	WEBP Format = "webp"
)

func init() {
	RegisterFormatEncoder(WEBP, func(w io.Writer, img image.Image) error { return libwebp.Encode(w, img, webpoptions.EncodingOptions{}) })
}
