// Code generated by gowrap. DO NOT EDIT.
// template: ../../assets/templates/middleware/recovery
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/logs -i Service -t ../../assets/templates/middleware/recovery -o recovering_middleware.go -l ""

import (
	"context"
	"fmt"

	"git.perx.ru/perxis/perxis-go/logs"
	"git.perx.ru/perxis/perxis-go/pkg/options"
	"go.uber.org/zap"
)

// recoveringMiddleware implements logs.Service that is instrumented with logging
type recoveringMiddleware struct {
	logger *zap.Logger
	next   logs.Service
}

// RecoveringMiddleware instruments an implementation of the logs.Service with simple logging
func RecoveringMiddleware(logger *zap.Logger) Middleware {
	return func(next logs.Service) logs.Service {
		return &recoveringMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *recoveringMiddleware) Delete(ctx context.Context, filter *logs.Filter) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Delete(ctx, filter)
}

func (m *recoveringMiddleware) Find(ctx context.Context, filter *logs.Filter, options *options.FindOptions) (fp1 *logs.FindResult, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Find(ctx, filter, options)
}

func (m *recoveringMiddleware) Log(ctx context.Context, entries []*logs.Entry) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Log(ctx, entries)
}
