// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/collaborators -i Collaborators -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/collaborators"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements collaborators.Collaborators that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   collaborators.Collaborators
}

// AccessLoggingMiddleware instruments an implementation of the collaborators.Collaborators with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next collaborators.Collaborators) collaborators.Collaborators {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, subject string) (role string, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("subject", subject),
	)

	role, err = m.next.Get(ctx, spaceId, subject)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("role", role),
		zap.Error(err),
	)

	return role, err
}

func (m *accessLoggingMiddleware) ListCollaborators(ctx context.Context, spaceId string) (collaborators []*collaborators.Collaborator, err error) {
	begin := time.Now()

	m.logger.Debug("ListCollaborators.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
	)

	collaborators, err = m.next.ListCollaborators(ctx, spaceId)

	m.logger.Debug("ListCollaborators.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("collaborators", collaborators),
		zap.Error(err),
	)

	return collaborators, err
}

func (m *accessLoggingMiddleware) ListSpaces(ctx context.Context, subject string) (spaces []*collaborators.Collaborator, err error) {
	begin := time.Now()

	m.logger.Debug("ListSpaces.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("subject", subject),
	)

	spaces, err = m.next.ListSpaces(ctx, subject)

	m.logger.Debug("ListSpaces.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("spaces", spaces),
		zap.Error(err),
	)

	return spaces, err
}

func (m *accessLoggingMiddleware) Remove(ctx context.Context, spaceId string, subject string) (err error) {
	begin := time.Now()

	m.logger.Debug("Remove.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("subject", subject),
	)

	err = m.next.Remove(ctx, spaceId, subject)

	m.logger.Debug("Remove.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Set(ctx context.Context, spaceId string, subject string, role string) (err error) {
	begin := time.Now()

	m.logger.Debug("Set.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("subject", subject),
		zap.Reflect("role", role),
	)

	err = m.next.Set(ctx, spaceId, subject, role)

	m.logger.Debug("Set.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
